Material Components
===================

Stateless UI components for react that follow material design.

Introduction
------------

material-components is a library of [React](https://facebook.github.io/react/) (0.14.0) user interface components based on [material design](https://www.google.com/design/spec/).

Unlike some other React based component libraries, material-components are completely stateless making them an ideal companion to libraries such as [Cerebral](http://christianalfoni.com/cerebral/) or [Redux](http://rackt.github.io/redux/). But they can also be used with other flux based frameworks or even without a framework at all.

The development of material-components has been sponsored by [Elastic Time](http://www.elastictime.com/).

Documentation, Demos & Code Examples
------------------------------------

Take a look at the [documentation app](http://garth.github.io/material-components) for demos and code examples.

![Demo](https://github.com/garth/material-components/blob/master/demo.png)

Installation
------------

```
npm install --save-dev material-components
```

Contribute
----------

Fork the repository

* `npm install`
* `npm run dev` runs dev mode which watches for changes and auto lints, tests and builds. Visit http://localhost:8080/webpack-dev-server/index.html to view the demo app.
* `npm test` runs the tests
* `npm run lint` lints the code
* `npm run build` compiles to es5

License
-------

MIT
